#
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/ScopeTest.pm,v
# Comment: Auxiliary subroutines for tests written in perl
# Release: scope-0-15_final
#
#    Copyright (C) 2001-2002 Andrzej Wasowski
#     
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#     
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#     
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# As all the scripts in this directory it is supposed to be run from
# scope/ not from scope/test/src
#
# ScopeTest.pm,v 1.3 2002/12/10 21:23:42 wasowski Exp
# 
package ScopeTest;
require Exporter;

our @ISA    = qw(Exporter);
our @EXPORT = qw(test_init test_finalize printres
                 printresln dotest remove_sandboxes
		 $testname $scope $scopedir);

# -- implementation

#define where to find scope (this may be moved out to a param one day)
$scopedir="./";
$scope=$scopedir . "scope";
$testname="NONAME";

sub test_init ($) {

	print "\nTesting " . $_[0] . "\n\n";
	$testname = $_[0];
}


sub printres ($) {

      	if ($_[0]) { print "passed"; }
	else { print "FAILED"; }
}

sub printresln ($) { 
	
	printres $_[0]; 
	print "\n" 
}

sub dotest (&$) {
      
     	my ($func,$name) = @_;
     	print "  Testing $name...";
	my $success = eval { &$func };
	printresln $success;
	return $success;
}

sub remove_sandboxes () {

	while (glob "test/sandbox*") { system "rm -Rf $_"; }
	return 1;
}

sub test_finalize ($) {

	print "\n$testname test ";
	printres $_[0];
	print ".\n\n";
}

