#!/usr/bin/perl -w 
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/tCodGenCs.pl,v
# Comment: Smoke tests of C1&CF based on random events and assertions in code
# Release: scope-0-15_final
#
#    Copyright (C) 2001-2003 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# NOTES:
#
# The idea about smoke test is to used debug version of interpreter code. The
# debug mode assertions should not be violated in testing.
# 
# tCodGenCs.pl,v 1.8 2003/08/06 07:29:57 wasowski Exp

use File::stat;
use test::src::ScopeTest;

$codgen = $ARGV[0];

if ($codgen ne "C1" && $codgen ne "CF") {
	print "Error: unknown code generator $codgen.\n";
	exit 1;
}

$preopts = "";

if ( $ARGV[1] ) { 
	$preopts = $ARGV[1];
}

$pos = 0;
	#filename, iterations, highest event no  
@cases = ( "test/run/actions01.vsp",  "2",    "0", 
	   "test/run/actions02.vsp",  "3",    "0",
	   "test/run/actions03.vsp",  "100",  "1",
	   "test/run/trans01.vsp",    "100",  "0",
	   "test/run/trans03.vsp",    "100",  "0",
	   "test/run/trans05.vsp",    "100",  "2",
	   "test/run/trans06.vsp",    "100",  "2",
	   "test/run/trans07.vsp",    "100",  "0",
	   "test/run/trans08.vsp",    "100",  "0",
	   "test/run/trans09.vsp",    "100",  "1",
	   "test/run/trans10.vsp",    "100",  "0",
	   "test/run/trans11.vsp",    "2000", "2",
	   "test/run/trans12.vsp",    "3",    "0",
	   "test/run/trans13.vsp",    "3",    "0",
	   "test/run/trans14.vsp",    "150",  "4",
	   "test/run/trans15.vsp",    "3",    "0",
	   "test/run/history02.vsp",  "10000","2",
	   "test/run/history03.vsp",  "1000000","5",
	   "test/run/history04.vsp",  "1000000","4",
	   "test/run/signals01.vsp",  "3",    "-1",
	   "test/run/signals02.vsp",  "3",    "-1",
	   "test/run/signals03.vsp",  "3",    "-1",
	   "test/run/cdplayer.vsp",   "100000",  "10",
	   "test/run/Lift.vsp",       "100000",  "3",
	   "test/run/peer.vsp",       "1000000", "49",	
   	   "test/run/climate.vsp",    "1000000", "12",
   	   "test/run/Clockradio.vsp", "1000000", "13",
   	   "test/run/mobile.vsp",     "1000000", "13",
   	   "test/run/mobileflat.vsp", "1000000", "14",
   	   "test/run/drusinsky89.vsp","1000000", "13",
           "test/run/trios01.vsp",    "10000",   "3",
           "test/run/trios02.vsp",    "10000",   "3",
           "test/run/trios03.vsp",    "10000",   "3",
	   "test/run/neg01.vsp",      "1000000", "0",
	   "test/run/neg02.vsp",      "1000000", "0",
	   "test/run/neg03.vsp",      "1000000", "0",
	   "test/run/spec01.vsp",     "200",     "0"
   );

sub testsmoke() {

	my $file    = $cases[$pos*3];
	my $iter    = $cases[$pos*3+1];
	my $eventno = $cases[$pos*3+2];
	my $exe = "test/src/testsmoke.pl $file $codgen test/sandbox/ $iter $eventno $preopts > /dev/null ";
#	print $exe . "\n";
	return ((system $exe) == 0);
}

ScopeTest::test_init( "CodGen$codgen smoke/debug tests $preopts" );

$success = 1;

for( $pos = 0; defined( $cases[$pos*3] ); $pos = $pos +1 ) {
	
	$success = ScopeTest::dotest(\&testsmoke, $cases[$pos*3]) && $success;
}
        

ScopeTest::test_finalize( $success );

