#!/usr/bin/perl -w 
#
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/tCommandLine.pl,v
# Comment: Test some trivialities about command line
# Release: scope-0-15_final
#
#    Copyright (C) 2001-2002 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# As all the scripts in this directory it is supposed to be run from
# scope/ not from scope/test/src
#
# tCommandLine.pl,v 1.6 2002/12/10 21:23:42 wasowski Exp
# 

use File::stat;
use test::src::ScopeTest;



sub clean_sandboxes () {

	while (glob "test/sandbox1/*") { unlink $_; }
	while (glob "test/sandbox2/*") { unlink $_; }

	return 1;
}

#one line should be returned by ./scope --version 

sub test_version () {
	
      open( WCOUT, "$ScopeTest::scope --version | wc --lines |"); 
      $number = <WCOUT>;
      close( WCOUT );
      return ($number == 1);
}

#if code generated with --release is smaller (in bytes) than
#the one generated with --debug we can assume that the option
#is passed more or less correctly

sub test_debug ($) {

        my $success = (system "$ScopeTest::scope --release -c test/run/Lift.vsp -dtest/sandbox1/") == 0;
	$success = $success && (system "$ScopeTest::scope --debug -c test/run/Lift.vsp -dtest/sandbox2/") == 0;
	my $sbR = -s("test/sandbox1/Lift.c");
	my $sbD = -s("test/sandbox2/Lift.c");
	clean_sandboxes();
	return ($success && $sbR < $sbD);
}

# launch the tests

ScopeTest::test_init "Command line interface";

$success = 1;    
$success = ScopeTest::dotest(\&test_version, "--version") &&
	   ScopeTest::dotest(\&test_debug, "--debug/--release influence on CodGenC1");


ScopeTest::test_finalize $success;

clean_sandboxes();
  	
	  

